ad_page_contract {
    View one event
    
    @author Ben Adida (ben@openforce.net)
    @creation-date April 09, 2002
    @cvs-id $Id: cal-item-view.tcl,v 1.14.2.2 2005/08/17 10:54:40 emmar Exp $
} {
    cal_item_id:integer
    {return_url ""}
}

ns_log notice "###### cal-item-view"
set user_id [ad_conn user_id]
set package_id [ad_conn package_id]

ns_log notice "###### check privilege read"
permission::require_permission -object_id $cal_item_id -privilege read
ns_log notice "##### after permission"

calendar::item::get -cal_item_id $cal_item_id -array cal_item

ns_log notice "##### got item [array get cal_item]"
set write_p [permission::write_permission_p -object_id $cal_item_id -creation_user $cal_item(creation_user)]


# Attachments?
if {$cal_item(n_attachments) > 0} {
    set item_attachments [attachments::get_attachments -object_id $cal_item(cal_item_id)]
} else {
    set item_attachments [list]
}

# no time?
set cal_item(no_time_p) [dt_no_time_p -start_time $cal_item(start_time) -end_time $cal_item(end_time)]

# Attachment URLs
if {[calendar::attachments_enabled_p]} {
  set attachment_options " | <A href=\"[attachments::add_attachment_url -object_id $cal_item(cal_item_id) -pretty_name $cal_item(name) -return_url "../cal-item-view?cal_item_id=$cal_item(cal_item_id)"]\" class=\"button\" >[_ calendar.Add_Attachment]</a>"
} else { 
    set attachment_options {} 
}

set date $cal_item(start_date)

ad_return_template 

